﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using Telerik.Windows.Controls;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication169
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            var children = Enumerable.Range(0, 10).Select(i => new Item() { Text = "xxxxxx xxxxxxxx xxxxxxxxxxxx xxxxxxxxxxx xxxxxx xxxxxxxxxx xx" });

            tree.ItemsSource = Enumerable.Range(0, 250).Select(i => new Item { Text = "xxxxxxxxxxxxxx xxxxxxxxxxxx xxxxxxxxxxxxxxxxx xxxxxxxxxx xx", Items = new List<Item>(children) });
        }

        private void tree_ItemPrepared(object sender, RadTreeViewItemPreparedEventArgs e)
        {
            e.PreparedItem.SizeChanged += new SizeChangedEventHandler(item_SizeChanged);
        }

        void item_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            var item = sender as RadTreeViewItem;
            var point = item.TransformToVisual(tree).Transform(new Point(0, 0));
            item.Width = tree.ActualWidth - point.X - 30;
        }
    }

    public class Item
    {
        public string Text { get; set; }

        public List<Item> Items { get; set; }
    }
}
